unit libMSL;

// libMSL Pascal header file

// libMSL,
// Copyright (c) 2004-2005, Michal Strehovsky
// www.migeel.sk

interface

uses Windows;

const libMSL_dll = 'libMSL.dll';

function LoadLib(LibFileName: PChar):HMODULE; stdcall; external libMSL_dll;
function FreeLib(HMODULE: hModule):LONGBOOL; stdcall; external libMSL_dll;
function GetProcAddr(HMODULE: hModule; ProcName: PChar):
 FARPROC; stdcall; external libMSL_dll;
function MappedDllToMsl(DLLOffset: Pointer; PSize: PDWORD):
 Pointer; stdcall; external libMSL_dll;
function DllToMsl(DllFileName, MslFileName: PChar): LONGBOOL;
 stdcall; external libMSL_dll;
function LoadMappedMsl(Base: Pointer): HMODULE; stdcall; external libMSL_dll;


type
  PMslHeader = ^TMslHeader;
  TMslHeader = packed record
    Signature:   DWORD; // must be MSL_SIGNATURE_10
    ImageBase:   DWORD; // preferred ImageBase of MSL file
    EntryPoint:  DWORD; // EntryPoint RVA
    SizeOfImage: DWORD; // Size of whole image in memory (not filesize!)
    NumberOfSections: DWORD; // number of TMlsSectionHeaders following this header
    ImportsVA: DWORD; // Import Table RVA
    ExportsVA: DWORD; // Export Table RVA
    RelocationsVA: DWORD; // Relocation Table RVA
    ResourcesVA: DWORD; // Resource directory RVA
  end;

  PMslSectionHeader = ^TMslSectionHeader;
  TMslSectionHeader = packed record
    RawAddress: DWORD;
    RawSize: DWORD;
    VirtualAddress: DWORD;
  end;

const MSL_SIGNATURE_10: DWORD   = $E011BF11;
      MslHeaderSize:DWORD       = SizeOf(TMslHeader);
      MslSectionHeaderSize:byte = SizeOf(TMslSectionHeader);


implementation

end.
